<script lang="ts">
import Vue from 'vue';
import SlpHorizontalRule from './horizontal-rule.vue';
import { toKebabCaseNonEnglish } from '@/lib/utils';

export default Vue.extend({
  name: 'Copy',
  components: {
    SlpHorizontalRule,
  },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  methods: {
    toKebabCaseNonEnglish,
  },
});
</script>

<template>
  <div
    :id="data.id"
    :data-aos="data.aos_animation"
    :data-aos-duration="data.aos_duration"
    class="slp-position-relative"
  >
    <SlpContainer>
      <div
        v-for="block in data.block"
        :key="block.header"
        class="container"
        :class="[
          {
            'slp-mb-64': block.hide_horizontal_rule && !block.no_margin_bottom,
          },
          block.margin_bottom ? `slp-mb-md-${block.margin_bottom}` : '',
        ]"
      >
        <span
          v-if="block.metadata"
          :id="block.metadata.id_tag || ''"
          class="slp-position-absolute"
          :data-slippers-scroll="block.metadata.id_tag || ''"
        />
        <div
          class="copy"
          :class="[
            { 'copy__align_center header': block.align_center },
            `slp-mt-md-${block.margin_top}`,
          ]"
        >
          <SlpRow class="slp-flex slp-flex-column slp-align-items-center">
            <SlpColumn :cols="block.column_size || 12">
              <SlpTypography
                v-if="block.header"
                :id="
                  block?.id ? block?.id : toKebabCaseNonEnglish(block.header)
                "
                variant="heading3"
                tag="h2"
                class="slp-mb-8 slp-mt-8"
                >{{ block.header }}</SlpTypography
              >
              <SlpTypography
                v-if="block.subtitle"
                tag="h3"
                variant="heading4"
                class="copy__subtitle"
                :class="{
                  'copy__subtitle--mobile--padding':
                    block.subtitle_mobile_padding,
                }"
                >{{ block.subtitle }}</SlpTypography
              >
              <div class="copy__body">
                <div
                  v-if="block.text"
                  class="slp-mb-32"
                  v-html="$md.render(block.text)"
                ></div>
                <slp-button
                  v-if="block.link_href"
                  :href="block.link_href"
                  :data-ga-name="block.link_data_ga_name"
                  :data-ga-location="block.link_data_ga_location"
                >
                  {{ block.link_text }}
                </slp-button>
              </div>
            </SlpColumn>
          </SlpRow>
          <SlpHorizontalRule v-if="!block.hide_horizontal_rule" />
        </div>
      </div>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
.container {
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  grid-gap: 15px;
  margin: 0 auto;
  max-width: 100%;
  position: relative;

  @media (min-width: $breakpoint-lg) {
    grid-template-columns: repeat(12, 1fr);
  }
}

.copy {
  grid-column: 1 / span 12;

  @media (min-width: $breakpoint-lg) {
    grid-column: 1 / span 12;
  }

  &__subtitle {
    @media (max-width: $breakpoint-lg) {
      &--mobile--padding {
        padding: 0 $spacing-16 $spacing-64 $spacing-16;
      }
    }
  }

  h4 {
    color: $color-text-300;
    font-size: 19px;
    font-weight: 400;
    line-height: 20px;
    margin-bottom: 16px;

    @media (min-width: $breakpoint-lg) {
      font-size: 23px;
      line-height: 28px;
    }
  }

  h3,
  &__body :deep h3 {
    font-size: 23px;
    line-height: 28px;

    @media (max-width: $breakpoint-sm) {
      font-size: 19px;
      line-height: 24px;
    }
  }

  h2,
  &__body :deep h2 {
    font-size: 36px;
    line-height: 40px;
  }

  &__body {
    grid-column: 1 / -1;
    color: $color-text-300;

    &:deep p {
      margin-bottom: 1em;
      font-size: 16px;
    }

    &:deep li {
      font-size: 16px;
    }

    &:deep ul {
      margin-left: $spacing-32;
    }

    & :deep p a {
      color: $color-text-link-100;
    }

    &:deep h3 {
      margin-top: $spacing-32;
      margin-bottom: $spacing-8;
    }

    &:deep blockquote {
      display: block;
      padding: 10px;
      margin: 0 0 10px;
      word-break: break-all;
      word-wrap: break-word;
      background-color: #f5f5f5;
      border: 1px solid #ccc;
      border-radius: 4px;
    }

    p,
    h4,
    li {
      font-size: 14px;
      line-height: 1.42857;
      color: #333;
    }

    h4 {
      margin-bottom: $spacing-32;
    }

    p {
      margin-bottom: unset;
    }

    &:deep table {
      table-layout: fixed;
      width: 100%;
      max-width: 100%;
      margin-bottom: 20px;
      background-color: transparent;
      border-collapse: collapse;
      border-spacing: 0;

      & > thead {
        &:first-child > :first-child > th {
          border-top: 1px solid $color-surface-200;
        }

        & > tr > th {
          vertical-align: bottom;
          padding: 8px;
          line-height: 1.42857;
          border: 1px solid $color-surface-200;
          border-bottom: 2px solid $color-surface-200;
        }
      }

      td {
        padding: 8px;
        line-height: 1.42857;
        vertical-align: top;
        border: 1px solid $color-surface-200;
        font-size: $text-body-1;
      }
    }
  }

  &__align_center {
    text-align: center;
  }
}

.header {
  color: $color-text-300;
  margin-bottom: $spacing-16;
}
</style>
